#pragma inline
/*                                                                          */
/*  FMEMCPY.C   -- The function farmemcpy(), a part of the HPAPLUS package  */
/*                                                                          */

#include "standard.h"
#include <dos.h>
#include <86models.h>

#if DATASIZE == 16

void far *farmemcpy(void far *dest, const void far *sco, unsigned len)
{
    asm push ds

    asm cld

    asm mov cx,len

    asm lds si,sco
    asm les di,dest

    asm shr cx,1
    asm jnc Do_MOVSW
    asm movsb

Do_MOVSW:
    asm rep movsw

    asm pop ds

    return(dest);
}

#endif