#include <dos.h>
#include <stdarg.h>
#include <stdlib.h>

#define mouseint() geninterrupt(0x33)		/* Converts to an INT 33H instr. */

#if defined(__COMPACT__) || defined(__LARGE__) || defined(__HUGE__)
#define LARGEDATA		1
#endif

void setmousecursor(void *image,int xspot,int yspot)
/* Sets the shape of the graphics mouse cursor. An image table must be created
   and its adress put into ( image ). The ( xspot ) and ( yspot ) arguments
   are the (x,y) location for the hot spot. */
{
#ifdef LARGEDATA
	_ES = FP_SEG(image);
	_DX = FP_OFF(image);
#else
	_ES = _DS;
	_DX = (unsigned) image;
#endif

	_AX = 9;
	_BX = xspot;
	_CX = yspot;

	mouseint();

}

void mousetexthard(int start,int stop)
/* Sets a hardware text mouse cursor */
{

	_AX = 0x0A;
	_BX = 1;
	_CX = start;
	_DX = stop;

	mouseint();

}

void mousetextsoft(int screen, int cursor)
/* Sets an attribute text cursor */
{

	_AX = 0x0A;
	_BX = 0;
	_CX = screen;
	_DX = cursor;

	mouseint();

}

