/* STRMID.C  -- Defines the strmid() function for the HPAPLUS library	*/

#pragma inline

#include <dos.h>
#include "86models.h"

char *strmid(char *dest, char *sco, unsigned loc, unsigned count)
	/* Copies from sco[loc] forward up to count characters into dest.		*/
	/* Returns dest + strlen(dest)											*/
{
	if ( count )
	{

#if ( DATASIZE > 16 )

		asm push ds

		_DI = FP_OFF(sco);
		_ES = FP_SEG(sco);

#else

		asm mov ax,ds
		asm mov es,ax

		_DI = (unsigned) sco;

#endif

		asm mov cx,0FFFFh
		asm xor al,al

		asm repne scasb

		asm jne No_End

		asm not cx
		asm dec cx


#if ( DATASIZE > 16 )

		_DI = FP_OFF(dest);
		_ES = FP_SEG(dest);

		if ( _CX >= loc )
		{
No_End:

			_SI = FP_OFF(sco);
			_DS = FP_SEG(sco);

#else

		_DI = (unsigned) dest;

		if ( _CX > loc )
		{
No_End:

			_SI = (unsigned) sco;

#endif

			asm add si,loc
			asm sub cx,loc

			asm mov dx,count

			asm cmp cx,dx
			asm jna Do_Run

			asm mov cx,dx

Do_Run:

			asm rep movsb

		}

		asm xor al,al
		asm stosb

#if ( DATASIZE > 16 )
		asm pop ds
#endif

	}
	else
		*dest = '\0';

	return(dest);

}



