/*																			*/
/*	86MODEL.H	--- define model information for those 80x86 processors		*/
/*																			*/


#ifndef CODESIZE

typedef short		Int16;
typedef long		Int32;

        
#if defined(__LARGE__) || defined(__HUGE__)

typedef	Int32		DType;
typedef Int32		CType;
#define	DATASIZE	32
#define	CODESIZE	32

#elif defined(__COMPACT__)

typedef Int32		DType;
typedef	Int16		CType;
#define DATASIZE	32
#define CODESIZE	16

#elif defined(__MEDIUM__)

typedef Int16		DType;
typedef Int32		CType;
#define DATASIZE	16
#define CODESIZE	32

#else

typedef Int16		DType;
typedef Int16		CType;
#define DATASIZE	16
#define CODESIZE	16

#endif

#endif
