/* CRTPLUS.H	-- Prototypes & defines for HPAPLUS lib CRT functions		*/

#ifndef _CRTPLUS_H

#define _CRTPLUS_H		1

#ifdef __STDC__
#define _Cdecl
#else
#define _Cdecl			cdecl
#endif

#ifdef __cplusplus
extern "C" {
#endif

void __emit__(unsigned char _byte,...);

#define keywait() __emit__(0x30,0xE4,0xCD,0x16)

int _Cdecl setfont8x8(int mode);
void _Cdecl setstdfont(int mode);
void _Cdecl setkeyspeed(int typerate, int pause);
char * _Cdecl cgetstr(char *str, int len);
int _Cdecl cyesno(void);
int _Cdecl inkey(void);

struct crt_video                /* Turbo C 2.0 _video structure             */
{
    unsigned char winleft;      /* Same as from gettextinfo()               */
    unsigned char wintop;
    unsigned char winright;
    unsigned char winbottom;
    unsigned char attribute;
    unsigned char normattr;
    unsigned char currmode;
    unsigned char screenheight;
    unsigned char screenwidth;
    unsigned char biosonly;     /* When nonzero disables directvideo        */
    unsigned char snowcheck;    /* If nonzero check "snow"                  */
	void far *videoram; 		/* Pointer to video RAM 					*/
    int directvideo;            /* The directvideo variable                 */
};

extern struct crt_video _Cdecl _video;

#define	KEY_CR			    13
#define KEY_BS			     8
#define KEY_TAB			     9
#define KEY_ESC			    27
#define KEY_NUL			(-253)
#define KEY_STAB        (-241)
#define KEY_AQ          (-240)
#define KEY_AW          (-239)
#define KEY_AE          (-238)
#define KEY_AR          (-237)
#define KEY_AT          (-236)
#define KEY_AU          (-235)
#define KEY_AI          (-234)
#define KEY_AO          (-233)
#define KEY_AP          (-232)
#define KEY_AA          (-226)
#define KEY_AS          (-225)
#define KEY_AD          (-224)
#define KEY_AF          (-223)
#define KEY_AG          (-222)
#define KEY_AH          (-221)
#define KEY_AJ          (-220)
#define KEY_AK          (-219)
#define KEY_AL          (-218)
#define KEY_AZ          (-212)
#define KEY_AX          (-211)
#define KEY_AC          (-210)
#define KEY_AV          (-209)
#define KEY_AB          (-208)
#define KEY_AN          (-207)
#define KEY_AM          (-206)
#define KEY_F1          (-197)
#define KEY_F2			(-196)
#define KEY_F3			(-195)
#define KEY_F4			(-194)
#define KEY_F5			(-193)
#define KEY_F6			(-192)
#define KEY_F7			(-191)
#define KEY_F8			(-190)
#define KEY_F9			(-189)
#define KEY_F10			(-188)
#define KEY_HOME		(-185)
#define KEY_UP			(-184)
#define KEY_PGUP		(-183)
#define KEY_LEFT		(-181)
#define KEY_RIGHT		(-179)
#define KEY_END			(-177)
#define KEY_DOWN		(-176)
#define KEY_PGDN		(-175)
#define KEY_INS			(-174)
#define KEY_DEL			(-173)
#define KEY_SF1			(-172)
#define KEY_SF2			(-171)
#define KEY_SF3			(-170)
#define KEY_SF4			(-169)
#define KEY_SF5			(-168)
#define KEY_SF6			(-167)
#define KEY_SF7			(-166)
#define KEY_SF8			(-165)
#define KEY_SF9			(-164)
#define KEY_SF10		(-163)
#define KEY_CF1			(-162)
#define KEY_CF2			(-161)
#define KEY_CF3			(-160)
#define KEY_CF4			(-159)
#define KEY_CF5			(-158)
#define KEY_CF6			(-157)
#define KEY_CF7			(-156)
#define KEY_CF8			(-155)
#define KEY_CF9			(-154)
#define KEY_CF10		(-153)
#define KEY_AF1			(-152)
#define KEY_AF2			(-151)
#define KEY_AF3			(-150)
#define KEY_AF4			(-149)
#define KEY_AF5			(-148)
#define KEY_AF6			(-147)
#define KEY_AF7			(-146)
#define KEY_AF8			(-145)
#define KEY_AF9			(-144)
#define KEY_AF10		(-143)
#define KEY_CPRTSC		(-142)
#define KEY_CLEFT		(-141)
#define KEY_CRIGHT		(-140)
#define KEY_CEND		(-139)
#define KEY_CPGDN		(-138)
#define KEY_CHOME		(-137)
#define KEY_A1			(-136)
#define KEY_A2			(-135)
#define KEY_A3			(-134)
#define KEY_A4			(-133)
#define KEY_A5			(-132)
#define KEY_A6			(-131)
#define KEY_A7			(-130)
#define KEY_A8			(-129)
#define KEY_A9			(-128)
#define KEY_A0			(-127)
#define KEY_AHYPHEN		(-126)
#define KEY_AEQUALS		(-125)
#define KEY_CPGUP		(-124)

#ifdef __cplusplus
}
#endif

#endif
