/* FIOPLUS.H -- Standard I/O additions from HPA lib							*/

#ifndef _FIOPLUS_H

#define _FIOPLUS_H		1

#ifdef __STDC__
#define _Cdecl
#else
#define _Cdecl			cdecl
#endif

#ifndef __STDIO_DEF
#include <stdio.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

long _Cdecl fsize( FILE *f );
char * _Cdecl fqfn( char *inname, char *outname );

typedef struct
{
    char *fname;
    char *pname;
    void *strs;
    char dirty;
}
INI;

INI * _Cdecl openini(const char *ininame, const char *progname);
void _Cdecl flushini(INI *ini);
void _Cdecl closeini(INI *ini);
char * _Cdecl getini(const char *vname, INI *ini);
int _Cdecl putini(const char *setstr, INI *ini);

#ifdef __cplusplus
}
#endif

#endif
