/* INKEY.C -- Define the inkey() function									*/

#include <bios.h>

int inkey(void)
{
	int key;

	key = bioskey(0);

	if ( key & 0xFF )
	{
		key &= 0xFF;
	}
	else
	{
		key = (key >> 8) - 0x0100;
	}

	return(key);
}
