/*	KEYSPEED.C -- Sets the keyboard typematic rate on an AT or PS/2		*/
/*	with an extended keyboard											*/

#include <dos.h>
#include <stdlib.h>
#include <math.h>

void setkeyspeed(int typerate, int pause)
{
	if ( typerate > 31 )
		typerate = 31;
	else if ( typerate < 0 )
		typerate = 0;

	if ( pause < 0 )
		pause = 0;
	else if ( pause > 3 )
		pause = 3;

	typerate += ( pause << 5 );

	outportb( 0x60, 0xF3 );				/* Prepare sending of rate code */

	for ( pause = 3000; pause; pause-- );
										/* Wait a little */

	outportb( 0x60, typerate );			/* Send second byte */
}