/* MOUSE.H Declarations of functions in MOUSExx.OBJ */

/* Constructed for use with Turbo C 2.0 */


#ifndef _MOUSE_H

#ifdef __STDC__
#define _Cdecl
#else
#define _Cdecl cdecl
#endif

#define _MOUSE_H		1

#ifdef __cplusplus
extern "C" {
#endif

int _Cdecl resetmouse(void);
void _Cdecl mouseon(void);
void _Cdecl mouseoff(void);
int _Cdecl mouse(int *xpos,int *ypos);
void _Cdecl placemouse(int xpos,int ypos);
int _Cdecl mousepress(int button,int *count,int *xpos,int *ypos);
int _Cdecl mouserelease(int button,int *count,int *xpos,int *ypos);
void _Cdecl mouselimit(int xmin,int ymin,int xmax,int ymax);
void _Cdecl setmousecursor(void *image,int xspot,int yspot);
void _Cdecl mousetexthard(int start,int stop);
void _Cdecl mousetextsoft(int screen, int cursor);
int _Cdecl mousebuffersize(void);
void * _Cdecl savemouse(void *buffer, int *bufsize);
void _Cdecl restoremouse(void *buffer);
void _Cdecl setmousepage(int page);
int _Cdecl mousepage(void);
void getmousemovement(int *dx,int *dy);
void mouseoffzone(int left,int up,int right,int down);
void getmousetouch(int *x, int *y, int *dbl);
void setmousetouch(int x, int y, int dbl);

enum MOU_BUTTONS { MOU_NONE = 0x00, MOU_LEFT = 0x01, MOU_RIGHT = 0x02,
                  MOU_BOTH = 0x03, MOU_MIDDLE = 0x03 };

#ifndef __STDC__

typedef void (far *mou_vect)();
void cdecl setmousetrap(int mask, mou_vect vector, int *oldmask,
	mou_vect *oldvector );
#define MOUSECALL void interrupt			/* For defining of trap fuctions */
enum MOU_MASK {  MOU_NOTHING = 0x00, MOU_MOVE = 0x01, MOU_PRLEFT = 0x02,
			MOU_RELEFT = 0x04, MOU_PRRIGHT = 0x08, MOU_RERIGHT = 0x10 };
#endif

#ifdef __cplusplus
}
#endif

#endif
